import { Duration, RemovalPolicy } from 'aws-cdk-lib';
import { Construct } from 'constructs';
import { ISecret, Secret } from 'aws-cdk-lib/aws-secretsmanager';
import { ReplicatedKey } from '@reapit-cdk/replicated-key';
import { Application } from './entra-id-types';
export type { Application } from './entra-id-types';
export interface EntraIDApplicationProps {
    readonly config: Application;
    readonly bootstrapClientSecret: ISecret;
    readonly removalPolicy?: RemovalPolicy;
}
export interface KeyCreationInfo {
    readonly displayName?: string;
    readonly hint?: string;
}
export interface CreateKeyProps {
    readonly keyInfo: KeyCreationInfo;
    readonly validFor: Duration;
    readonly removalPolicy?: RemovalPolicy;
    readonly replicatedKey?: ReplicatedKey;
    readonly replicaRegions?: string[];
}
export interface EntraIDApplicationKey {
    readonly displayName: string;
    readonly startDateTime: string;
    readonly keyId: string;
    readonly endDateTime: string;
    readonly hint: string;
    readonly secret: Secret;
}
export declare class EntraIDApplication extends Construct {
    private app;
    private keyProvider;
    private keyRotationLambda;
    private bootstrapClientSecret;
    constructor(scope: Construct, id: string, props: EntraIDApplicationProps);
    getAttString(attr: keyof Application): string;
    createKey(scope: Construct, id: string, props: CreateKeyProps): EntraIDApplicationKey;
}
