"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/lambdas/get-access-token.ts
var get_access_token_exports = {};
__export(get_access_token_exports, {
  getAccessToken: () => getAccessToken
});
module.exports = __toCommonJS(get_access_token_exports);
var getAccessToken = async ({
  tenantId,
  clientId,
  clientSecret,
  scopes
}) => {
  const res = await fetch(`https://login.microsoftonline.com/${tenantId}/oauth2/v2.0/token`, {
    headers: {
      "content-type": "application/x-www-form-urlencoded"
    },
    method: "post",
    body: new URLSearchParams({
      client_id: clientId,
      scope: scopes?.length ? scopes.join(" ") : "https://graph.microsoft.com/.default",
      grant_type: "client_credentials",
      client_secret: clientSecret
    }).toString()
  });
  if (!res.ok) {
    throw new Error(`microsoft /token call failed with ${res.status}: ${await res.text()}`);
  }
  const { access_token } = await res.json();
  if (!access_token) {
    throw new Error("no access token returned from /token call");
  }
  return access_token;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getAccessToken
});
